/* InputBox Function for password */
#include "zip.h"
#include "crypt.h"

#ifdef CRYPT /* If no crypt, don't use */

#include "windows.h"
#include "resource.h"

CHAR lpszPassword[PWLEN+1]; // PWLEN = 80
CHAR lpszPrompt[20];
WORD cchPassword;
BOOL pwork;
INT rcode;

int getp OF ((char *, char *, int));

BOOL CALLBACK PassProc(hDlg, message, wParam, lParam)
HWND hDlg;                /* window handle of the dialog box */
UINT message;             /* type of message                 */
UINT wParam;              /* message-specific information    */
LONG lParam;
{
   switch (message) {
      case WM_INITDIALOG:
            /* Set Password character to an asterisk (*) */
            diag("init dialog");
            SendDlgItemMessage(hDlg,
                IDE_PASSWORDEDIT,
                EM_SETPASSWORDCHAR,
                (WPARAM) '*',
                (LPARAM) 0);

            /* Set the prompt */
            SendDlgItemMessage(hDlg,
                IDC_PROMPT,
                WM_SETTEXT,
                (WPARAM) 0,
                (LPARAM) lpszPrompt);

            /* Set the default push button to "Cancel." */
            SendMessage(hDlg,
                DM_SETDEFID,
                (WPARAM) IDCANCEL,
                (LPARAM) 0);

            pwork = TRUE;
            rcode = 0;
            return TRUE;

        case WM_COMMAND:
           /*
            * Set the default push button to "OK" when the user
            * enters text.
            */
           diag("WM_COMMAND in dialog");
           if (HIWORD (wParam) == EN_CHANGE &&
               LOWORD(wParam) == IDE_PASSWORDEDIT)
                SendMessage(hDlg,
                    DM_SETDEFID,
                    (WPARAM) IDOK,
                    (LPARAM) 0);

            switch(wParam) {
                case IDOK:
                    /* Get number of characters. */
                    cchPassword = (WORD) SendDlgItemMessage(hDlg,
                        IDE_PASSWORDEDIT,
                        EM_LINELENGTH,
                        (WPARAM) 0,
                        (LPARAM) 0);

                    if (cchPassword >= PWLEN+1) {
                        MessageBox((HWND)global_handle,
                            "Too many characters.",
                            "Error",
                            MB_OK);
                        EndDialog(hDlg, TRUE);
                        rcode = IZ_PW_ERROR;
                        return FALSE;
                    }

                    else if (cchPassword == 0) {
                        MessageBox((HWND)global_handle,
                            "No characters entered.",
                            "Error",
                            MB_OK);
                        EndDialog(hDlg, TRUE);
                        rcode = IZ_PW_CANCELALL;
                        return FALSE;
                    }

                    /*
                     * Put the number of characters into first word
                     * of buffer.
                     */
                    *((LPWORD)lpszPassword) = cchPassword;

                    /* Get the characters. */
                    SendDlgItemMessage(hDlg,
                        IDE_PASSWORDEDIT,
                        EM_GETLINE,
                        (WPARAM) 0,       /* line 0 */
                        (LPARAM) lpszPassword);

                    /* Null-terminate the string. */
                    lpszPassword[cchPassword] = 0;

                    /* Call a local password-parsing function. */
                    rcode = IZ_PW_ENTERED;
                    EndDialog(hDlg, TRUE);
                    return TRUE;

                case IDCANCEL:
                    rcode = IZ_PW_CANCELALL;
                    EndDialog(hDlg, TRUE);
                    return TRUE;
            } // end inner switch
            return 0;
   } // end outer switch
   return FALSE;
   UNREFERENCED_PARAMETER(lParam);
}

/*--------------------------------------------------------*/
/* Sample call:                                           */
/* if getp("Enter password: ", key, PWLEN + 1) == NULL) { */
/* where key is a pointer to the global password buffer   */
/*--------------------------------------------------------*/
int getp(msg, pkey, siz)
char *msg;
char *pkey;
int siz;
{
   HINSTANCE hnd;

   pwork = FALSE;
   rcode = 0;
   cchPassword = 0;

   diag("in getp() of passmsg.c");

   strcpy(lpszPrompt, msg); // prompt string follows the size
   lpszPassword[0]=(CHAR)0; // NULL out the initial password

   // hnd = global_handle; THIS HANDLE DID NOT WORK - WHY?

   hnd = GetModuleHandle("zipdll.dll");
   if (hnd != 0) {
      diag("trying to bring up the dialog");
      if (DialogBox(hnd, MAKEINTRESOURCE(IDD_DIALOG1),
           (HWND)global_handle, (DLGPROC) PassProc) == FALSE) {
         MessageBox((HWND)global_handle, "DialogBox failed",
                                 "Procedure Failure", MB_OK);
         return IZ_PW_ERROR;
      }

      if (!pwork)
         return IZ_PW_ERROR;

      key_len = cchPassword;
      memccpy(pkey, lpszPassword, '\0', key_len);

      sprintf(ewemsg, "password=%s Len=%d", lpszPassword, key_len);
      diag(ewemsg); 
      return rcode;
   }
   return 0; /* no window handle - we can't prompt the user */
}
#endif /* crypt */
